package ch.zhaw.projekt2.turnierverwaltung.main.gameScheduleView;

import ch.zhaw.projekt2.turnierverwaltung.*;

import java.util.ArrayList;
import java.util.List;


public class GameDecorator implements IsObservable{
    private Game game;
    private List<IsObserver> listener = new ArrayList<>();

    public GameDecorator (Game game) {
        this.game = game;
    }

    @Override
    public void addListener(IsObserver observer) {
        listener.add(observer);
    }

    @Override
    public void removeListener(IsObserver observer) {
        listener.remove(observer);
    }

    public void saveGameResult(String points1, String points2){
        if(points1.length() > 0){
            game.setPoints1(Integer.parseInt(points1));
        } else {
            game.setPoints1(0);
        }
        if(points2.length() > 0) {
            game.setPoints2(Integer.parseInt(points2));
        } else {
            game.setPoints2(0);
        }
        informListener();
    }

    public void saveGamePlace(Place place){
        game.setPlace(place);
        informListener();
    }

    public String getPoints1() {
       return String.valueOf(game.getPoints1());
    }

    public String getPoints2() {
        return String.valueOf(game.getPoints2());
    }

    public String getParticipantOne() {
        if (game.getParticipant1() != null) {
            return game.getParticipant1().toString();
        }
        return "1";
    }

    public String getParticipantTwo() {
        if (game.getParticipant2() != null) {
            return game.getParticipant2().toString();
        }
        return "2";
    }

    public void refreshParticipants(){
        game.refreshParticipants();
        informListener();
    }

    public Place getPlace() {
        return game.getPlace();
    }

    public void informListener() {
        for(IsObserver observer : listener) {
            observer.update();
        }
    }
}
